import datetime

class Timer(object):
    def __init__(self):
        self.times = [(datetime.datetime.now(), "start")]
    def tick(self, msg):
        self.times.append((datetime.datetime.now(), msg))
    def report(self):
        n = len(self.times)
        if n < 2:
            return "not enough ticks"
        t0 = self.times[0][0]
        tn = self.times[-1][0]
        dur = tn - t0
        dur = dur.seconds * 1000000 + dur.microseconds
        print "#"
        print "# Timing report total duration:", dur, "us"
        print "#"
        x = float(80) / dur
        lpad = ''
        for t, msg in self.times[1:]:
            _dur = t - t0
            _dur = _dur.seconds * 1000000 + _dur.microseconds
            bars = int(x * _dur)
            s = ''
            for i in range(bars):
                s += "="
            print lpad+s, msg, "(%dus)"%_dur
            for i in range(bars):
                lpad += " "
            t0 = t
        print "#"
        print "# end report"
        print "#"

